#ifndef OS_THREAD_H
#define OS_THREAD_H

#if defined(__unix__) || (defined(__APPLE__) && defined(__MACH__)) // Fuck you, apple

#include <pthread.h>
typedef pthread_t os_thread_t;

#elif defined(_WIN32)

#include <windows.h>
typedef struct Struct_OSThread {
	HANDLE 	thread_handle;
	void**  return_value_storage;
} os_thread_t;

#else
#error "Unknown Threading Standard, feel free to add support via a fork/PR"
#endif

typedef void* (*ThreadFunction) (void* arg);

int OSThread_Create(os_thread_t* destination, ThreadFunction subroutine, void* arg);
int OSThread_Kill(os_thread_t* thread);
int OSThread_Join(os_thread_t* thread, void** thread_return);
int OSThread_Destroy(os_thread_t* thread);

#endif
